unit reduceunit;
{reduce images by two-way averaging}
interface
uses memtypes,quickdraw,osintf,toolintf,packintf,fixmath,
		bitpackunit,shortfixunit;

procedure reduce_unpack(	source:ptr;
							source_bits_per_pixel:integer;
							source_imagewidth:longint;
							dest:ptr;
							dest_max_byte_size:longint);
							
							
procedure reduce_fix_mean(	source:ptr;
							dest:ptr;
							dest_max_byte_size:longint;
							nreduce:integer;
							sourceimagewidth:longint;
							sourceimagelength:longint;
							sourcerow:longint;
							var destrow:longint;
							var destavecount:integer;
							var writedestrow:boolean);
							
function reduced_size(ii:longint;nreduce:integer):longint;

implementation

function max(i,j:longint):longint;
begin
if i>j then max:=i else max:=j;
end;
function min(i,j:longint):longint;
begin
if i<j then min:=i else min:=j;
end;

function reduced_size(ii:longint;nreduce:integer):longint;
{division with round up}
begin
reduced_size:=(ii+nreduce-1) div nreduce;
end;{proc}

procedure reduce_unpack(	source:ptr;
							source_bits_per_pixel:integer;
							source_imagewidth:longint;
							dest:ptr;
							dest_max_byte_size:longint);
var
	low_bit_alignment:integer;
	dest_item_count:longint;
begin
low_bit_alignment:=shortfix_fraction_digits-source_bits_per_pixel;

bitstream_unpack(source,source_imagewidth,source_bits_per_pixel,
				dest,dest_max_byte_size,
				dest_item_count,
				shortfixbytes,
				low_bit_alignment);
end;{proc}

procedure reduce_fix_mean(	source:ptr;
							dest:ptr;
							dest_max_byte_size:longint;
							nreduce:integer;
							sourceimagewidth:longint;
							sourceimagelength:longint;
							sourcerow:longint;
							var destrow:longint;
							var destavecount:integer;
							var writedestrow:boolean);
var startdestrow:boolean;
    enddestrow:boolean;
	rowmod:integer;
	destimagewidth:longint;
	i,j,ja,jb:longint;
	sum:shortfix;
begin
rowmod:=(sourcerow-1) mod nreduce;
startdestrow:=(rowmod=0);
enddestrow:=(rowmod=(nreduce-1)) or (sourcerow=sourceimagelength);
destimagewidth:=reduced_size(sourceimagewidth,nreduce);
destimagewidth:=min(dest_max_byte_size div shortfixbytes,destimagewidth);

if sourcerow=1 then destrow:=0;
if startdestrow then
     begin
	 for i:=1 to destimagewidth do shortfixarrayptr(dest)^[i]:=0;
	  destavecount:=0;
	  destrow:=destrow+1;
	 end;
	 
destavecount:=destavecount+1;	 
writedestrow:=enddestrow;

{horizontal average}
ja:=1;
jb:=nreduce;
for i:=1 to destimagewidth do
	begin
	sum:=0;
	for j:=ja to jb do
		begin
		sum:=sum+shortfixarrayptr(source)^[j];
		end;
	sum:=sum div (jb-ja+1);
	shortfixarrayptr(dest)^[i]:=shortfixarrayptr(dest)^[i]+sum;
	ja:=min(ja+nreduce,sourceimagewidth);
	jb:=min(jb+nreduce,sourceimagewidth);
	end;
	
{vertical average at end of row}
if enddestrow then
	 for i:=1 to destimagewidth do
	 begin
	 shortfixarrayptr(dest)^[i]:=shortfixarrayptr(dest)^[i] div destavecount;
	 end;


end;{proc}

end.